# C-programmering i Linux, macOS, BSD och Solaris (tredje utgåvan)
Här finner du all exempelkod för tredje utgåvan av boken *C-programmering i
Linux, macOS, BSD och Solaris* (ISBN: 978-91-983300-7-6).

Boken går att köpa från [CyberInfo Sverige](https://www.cyberinfo.se/bocker/),
[Bokus](https://www.bokus.com/cgi-bin/product_search.cgi?publisher=CyberInfo%20Sverige)
och
[Adlibris](https://www.adlibris.com/se/sok?filter=publisher%3ACyberInfo%20Sverige)
från och med hösten/vintern 2021.

Är du nyfiken på boken så titta gärna i [innehållsförteckningen](https://www.cyberinfo.se/dokument/c-prog_innehallsforteckning_3e_utg.html).

## Baksidetexten
**C-programmering i Linux, macOS, BSD och Solaris** lär först ut grunderna i
C-programmering så att vi har en stabil grund att stå på. Denna del vänder sig
mot de som är nya på C-programmering eller för de som behöver fräscha upp sina
C-kunskaper. Därefter börjar vi att programmera alltmer mot Unixsystem med
hjälp av bland annat systemanrop. Vi lär oss att skapa och använda demoner,
standard input- och output, filrättigheter, FIFO, processhantering, make-filer,
meddelandeköer med mera. Vi får också lära oss hur man kopplar samman flera
program med hjälp av rörledningar och skalskript. Mot slutet av boken tittar vi
på hur man använder felsökningsverktyg som GDB, LLDB och Valgrind. 

Grundtanken med boken är att du som läsare bara ska behöva en enda bok för att
komma igång att utveckla program och verktyg för Unixsystem. Boken är uppbyggd
på devisen att lära genom exempel. I boken finns över 180 exempelprogram, både
stora och små. Efter varje kapitel finns dessutom övningsuppgifter, så att du
som läsare ska kunna arbeta med boken på egen hand. 

I denna tredje utgåva har stora delar skrivits om för att göra boken mer
lättläst, relevant och uppdaterad. Bland annat har kapitlet om IPC utökats till
att även innefatta Unix-sockets. Ett helt kapitel om TCP/IP-programmering har
också lagts till. En del förbättringar har också gjorts av exempelprogrammen i
boken.

## Framsida
![C-programmering i Linux, macOS, BSD och
Solaris](c-prog-tredje-utg-framsida.png)
